argindex = 0;
rtsetparams(48000, 2, 512);
load("TRANS");
outfile = s_arg(argindex + 1);
if (outfile != 0) {
	set_option("clobber_on", "audio_off");
	rtoutput(outfile);
}
	
// set this to the number of levels of recursion you want
maxdepth = 14;

files = {
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  021.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  024.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  027.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  030.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  033.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  036.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  039.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  042.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  046.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  048.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  051.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  054.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  057.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  060.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  063.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  066.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  069.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  072.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  075.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  078.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  081.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  084.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  087.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  090.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  093.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  096.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  099.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  102.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  105.aif",
	"/Library/Application Support/GarageBand/Instrument Library/Sampler/Sampler Files/Steinway Grand Piano/Steinway V2/Steinway V2  108.aif" };


attackpoints = { 0.0, 0.61803398875, 1.0 };

float scatter(float start, float dur, float gain, float depth)
{
	count = len(attackpoints) - 1;
	event = 0;
	transp = 0.01 * (depth - 1);
	if (depth < maxdepth) {
		while (event < count) {
            localstart = start + (attackpoints[event] * dur);
            rtinput(files[depth * 30 / maxdepth], "mem");
			filedur = DUR();
			// each depth moves father from center (0.5)
			pan = 0.5 + (pickrand(-1, 1) * 0.5 * depth/maxdepth);
			TRANS3(localstart, 0, translen(filedur, transp), gain, transp, 0, pan);
            localdur = ((attackpoints[event+1] - attackpoints[event]) * dur);
			localgain = gain * 0.75;
			scatter(localstart, localdur, localgain, depth + 1);
			event = event + 1;
		}
	}
	return 0;
}

scatter(0, 30, 0.85, 0);
